/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: JobInfo.cpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: AVRJ݊킪sׂێ׽B͖̏
 *			  sh܂B
 *
 ****************************************************************************/

#include "JobInfo.hpp"

#include <conio.h>

#define VERSIONSTRING "$Revision: 1163 $"	// ł̕͏o͂ł̎gp̂

#define TIMEOUT 5
#define TIMEOUTSTRING "5"

JobInfo::JobInfo()
{
	/* ϐ */
	showHelp = false;
	silentMode = false;
	noProgressIndicator = false;
	readSignature = false;
	chipErase = false;
	getHWrevision = false;
	getSWrevision = false;
	programFlash = false;
	programEEPROM = false;
	readFlash = false;
	readEEPROM = false;
	verifyFlash = false;
	verifyEEPROM = false;
	readLockBits = false;
	readFuseBits = false;
	readOSCCAL = false;

	deviceName.erase();
	inputFileFlash.erase();
	inputFileEEPROM.erase();
	outputFileFlash.erase();
	outputFileEEPROM.erase();

	OSCCAL_Parameter = -1;
	OSCCAL_FlashAddress = -1;
	OSCCAL_EEPROMAddress = -1;

	programLockBits = -1;
	verifyLockBits = -1;

	programFuseBits = -1;
	programExtendedFuseBits = -1;
	verifyFuseBits = -1;
	verifyExtendedFuseBits = -1;

	memoryFillPattern = -1;

	flashStartAddress = -1;
	flashEndAddress = -1;

	eepromStartAddress = -1;
	eepromEndAddress = -1;

	comPort = -1;
}

void JobInfo::parseCommandline( int argc, char *argv[] )
{
	char * param;							// ݉͂ꂽҰێꎞ߲
	int comma;								// ڽ͈͓','qpꎞʒu

	/* pިڸ؂擾 */
	string ownpath = argv[0];
	int slash_pos = ownpath.find_last_of( "\\/" );	// Ō'/'܂'\'
	if( slash_pos == string::npos )			// ?
	{
		ownpath.assign( "." );				// ݂ިڸ؂AVROSP.exe߽
	} else
	{
		ownpath.erase( slash_pos );			// Ō'/'q܂ޏ苎
	}

	searchpath.push_back( "." );			// ݂ިڸĂǉ
	searchpath.push_back( ownpath );		// ̂߂ɕۑ

	if( argc <= 1 )
	{
		showHelp = true;
		return;
	}

	/* ߍsҰʂČJԂ */
	for( int i = 1; i < argc; i++ )
	{
		param = argv[i];

		/* '-'Ŏn܂Ұ */
		if( param[0] != '-' )
			throw new ErrorMsg( "All parameters must start with '-'!" );

		if( strlen( param ) <= 1 )
			throw new ErrorMsg( "Parameters cannot be just the minus without any characters!" );

		/* āA */
		switch( param[1] )
		{
			case 'a':	// ڽ͈͎w
				if( strlen( param ) <= 2 )
					throw new ErrorMsg( "Cannot use -a without memory type!" );

				if( strlen( param ) <= 5 )
					throw new ErrorMsg( "Cannot use -a without start and end address!" );

				/* ','ʒu16iϊ邽߂ɂ'0'ɐݒ */
				comma = 2;
				while( (param[comma] != 0) && (param[comma] != ',') )
					comma++;

				if( comma == strlen( param ) )	// ','Ȃ?
					throw new ErrorMsg( "No comma separator found in -a parameter!" );

				param[comma] = 0;				// ₻16iϊp2̓Ɨ

				/* Eϊ */
				switch( param[2] )
				{
					case 'f':	// ׯ ڽ͈
						try
						{
							flashStartAddress = convertHex( param + 3 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Number format error in start limit for -af parameter!" );
						}

						try
						{
							flashEndAddress = convertHex( param + comma + 1 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Number format error in end limit for -af parameter!" );
						}

						if( flashEndAddress < flashStartAddress )
							throw new ErrorMsg( "Cannot have Flash end limit less than start limit!" );

						break;

					case 'e':	// EEPROMڽ͈
						try
						{
							eepromStartAddress = convertHex( param + 3 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Number format error in start limit for -ae parameter!" );
						}

						try
						{
							eepromEndAddress = convertHex( param + comma + 1 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Number format error in end limit for -ae parameter!" );
						}

						if( eepromEndAddress < eepromStartAddress )
							throw new ErrorMsg( "Cannot have EEPROM end limit less than start limit!" );

						break;

					default:
						throw new ErrorMsg( "Unknown choice for -a, use -af or -ae!" );

				}

				break;


			case 'b':	// ԍ擾
				if( strlen( param ) != 3 )
					throw new ErrorMsg( "Specify SW og HW revision, not just -b!" );

				switch( param[2] )
				{
					case 'h':	// ʰ޳
						getHWrevision = true;
						break;

					case 's':	// ĳ
						getSWrevision = true;
						break;

					default:
						throw new ErrorMsg( "Unknown choice for -b, use -bs or -bh!" );
				}

				break;


			case 'c':	// COM߰Ďw
				if( strlen( param ) != 6 )
					throw new ErrorMsg( "COM port parameter syntax is -cCOMx!" );

				if( param[2] != 'C' || param[3] != 'O' || param[4] != 'M' )
					throw new ErrorMsg( "COM port parameter syntax is -cCOMx!" );

				if( param[5] < '1' || param[5] > '8' )
					throw new ErrorMsg( "Use COM1 to COM8!" );

				comPort = param[5] - '0';		// COM߰Č𐔒lɕϊ
				break;


			case 'd':	// ޲w
				if( strlen( param ) <= 2 )
					throw new ErrorMsg( "Cannot use -d without the device name!" );

				/* ޲׽ϐɕ */
				deviceName.assign( param + 2 );
				break;


			case 'e':	// ۸ݸޑOߏ
				if( strlen( param ) != 2 )
					throw new ErrorMsg( "Parameter -e needs no extra arguments!" );

				chipErase = true;
				break;


			case 'E':	// g˭ ޯĐݒ
				if( strlen( param ) != 4 )
					throw new ErrorMsg( "Use two hex digits for the -E parameter!" );

				try
				{
					programExtendedFuseBits = convertHex( param + 2 );
				}
				catch( ErrorMsg * e )
				{
					delete e;
					throw new ErrorMsg( "Hex number format error for -E parameter!" );
				}

				break;


			case 'f':	// ˭ ޯĐݒ
				if( strlen( param ) != 6 )
					throw new ErrorMsg( "Use four hex digits for the -f parameter!" );

				try
				{
					programFuseBits = convertHex( param + 2 );
				}
				catch( ErrorMsg * e )
				{
					delete e;
					throw new ErrorMsg( "Hex number format error for -f parameter!" );
				}

				break;


			case 'F':	// ˭ ޯďƍ
				if( strlen( param ) != 6 )
					throw new ErrorMsg( "Use four hex digits for the -F parameter!" );

				try
				{
					verifyFuseBits = convertHex( param + 2 );
				}
				catch( ErrorMsg * e )
				{
					delete e;
					throw new ErrorMsg( "Hex number format error for -F parameter!" );
				}

				break;


			case 'g':	// Î⑀
				if( strlen( param ) != 2 )
					throw new ErrorMsg( "Parameter -g needs no extra arguments!" );

				silentMode = true;
				break;


			case 'G':	// g˭ ޯďƍ
				if( strlen( param ) != 4 )
					throw new ErrorMsg( "Use two hex digits for the -G parameter!" );

				try
				{
					verifyExtendedFuseBits = convertHex( param + 2 );
				}
				catch( ErrorMsg * e )
				{
					delete e;
					throw new ErrorMsg( "Hex number format error for -G parameter!" );
				}

				break;


			case 'h':	// ߉
			case '?':	// ߉
				if( strlen( param ) != 2 )
					throw new ErrorMsg( "Parameter -h and -? needs no extra arguments!" );

				showHelp = true;
				break;


			case 'i':	// َ̧w
				if( strlen( param ) <= 2 )
					throw new ErrorMsg( "Cannot use -i without memory type!" );

				if( strlen( param ) <= 3 )
					throw new ErrorMsg( "Cannot use -i without file name!" );

				/* ̧ٖ𐳂׽ϐɕ */
				switch( param[2] )
				{
					case 'f':	// ׯp̧
						inputFileFlash.assign( param + 3 );
						break;

					case 'e':	// EEPROMp̧
						inputFileEEPROM.assign( param + 3 );
						break;

					default:
						throw new ErrorMsg( "Unknown choice for -i, use -if or -ie!" );
				}

				break;

			case 'l':	// {ޯĐݒ
				if( strlen( param ) != 4 )
					throw new ErrorMsg( "Use two hex digits for the -l parameter!" );

				try
				{
					programLockBits = convertHex( param + 2 );
				}
				catch( ErrorMsg * e )
				{
					delete e;
					throw new ErrorMsg( "Hex number format error for -l parameter!" );
				}

				break;

			case 'L':	// {ޯďƍ
				if( strlen( param ) != 4 )
					throw new ErrorMsg( "Use two hex digits for the -l parameter!" );

				try
				{
					verifyLockBits = convertHex( param + 2 );
				}
				catch( ErrorMsg * e )
				{
					delete e;
					throw new ErrorMsg( "Hex number format error for -L parameter!" );
				}

				break;

			case 'o':	// oَ̧w
				if( strlen( param ) <= 2 )
					throw new ErrorMsg( "Cannot use -o without memory type!" );

				if( strlen( param ) <= 3 )
					throw new ErrorMsg( "Cannot use -o without file name!" );

				/* ̧ٖ𐳂׽ϐɕ */
				switch( param[2] )
				{
					case 'f':	// ׯpo̧
						outputFileFlash.assign( param + 3 );
						break;

					case 'e':	// EEPROMpo̧
						outputFileEEPROM.assign( param + 3 );
						break;

					default:
						throw new ErrorMsg( "Unknown choice for -o, use -of or -oe!" );
				}

				break;

			case 'O':	// OSCCAL޲ēǂݍ
				switch( strlen( param ) )
				{
					case 2:		// w肳ꂽlȂAŏOSCCAL޲Ăgp
						readOSCCAL = true;
						OSCCAL_Parameter = 0;		// ŏOSCCAL޲
						break;

					case 3		// w肳ꂽ޲ĎwW
					case 4:
						readOSCCAL = true;
						try
						{
							OSCCAL_Parameter = convertHex( param + 2 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Hex number format error for -O parameter!" );
						}

						break;

					case 5:		// ڒlw
						if( param[2] != '#' )
							throw new ErrorMsg( "Use one or two hex digits for -O and two for -O#!" );

						readOSCCAL = false;
						try
						{
							OSCCAL_Parameter = convertHex( param + 3 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Hex number format error for -O# parameter!" );
						}

						break;

					default:
						throw new ErrorMsg( "Invalid use of -O or -O# parameter!" );
				}

				break;

			case 'p':	// ް
				if( strlen( param ) != 3 )
					throw new ErrorMsg( "Specify memory type, not just -p!" );

				switch( param[2] )
				{
					case 'f':	// ׯ ؏
						programFlash = true;
						break;

					case 'e':	// EEPROM
						programEEPROM = true;
						break;

					case 'b':	// 
						programFlash = true;
						programEEPROM = true;
						break;

					default:
						throw new ErrorMsg( "Unknown choice for -p, use -pf, -pe or -pb!" );
				}

				break;

			case 'q':	// S˭ ޯēǂݍ
				if( strlen( param ) != 2 )
					throw new ErrorMsg( "Parameter -q needs no extra arguments!" );

				readFuseBits = true;
				break;

			case 'r':	// ްǂݍ
				if( strlen( param ) != 3 )
					throw new ErrorMsg( "Specify memory type, not just -r!" );

				switch( param[2] )
				{
					case 'f':	// ׯ ؓǂݍ
						readFlash = true;
						break;

					case 'e':	// EEPROMǂݍ
						readEEPROM = true;
						break;

					case 'b':	// ǂݍ
						readFlash = true;
						readEEPROM = true;
						break;

					default:
						throw new ErrorMsg( "Unknown choice for -r, use -rf, -re or -rb!" );
				}

				break;

			case 's':	// [޲ēǂݍ
				if( strlen( param ) != 2 )
					throw new ErrorMsg( "Parameter -s needs no extra arguments!" );

				readSignature = true;
				break;

			case 'S':	// ؂OSCCALl
				if( strlen( param ) <= 2 )
					throw new ErrorMsg( "Cannot use -S without memory type!" );

				if( strlen( param ) <= 3 )
					throw new ErrorMsg( "Cannot use -S without byte address!" );

				switch( param[2] )
				{
					case 'f':	// ׯ ڽɏ
						try
						{
							OSCCAL_FlashAddress = convertHex( param + 3 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Cannot convert hex number for -Sf parameter!" );
						}
						break;

					case 'e':	// EEPROMڽɏ
						try
						{
							OSCCAL_EEPROMAddress = convertHex( param + 3 );
						}
						catch( ErrorMsg * e )
						{
							delete e;
							throw new ErrorMsg( "Cannot convert hex number for -Se parameter!" );
						}
						break;

					default:
						throw new ErrorMsg( "Unknown choice for -S, use -Sf or -Se!" );
				}

				break;

			case 'v':	// ްƍ
				if( strlen( param ) != 3 )
					throw new ErrorMsg( "Specify memory type, not just -v!" );

				switch( param[2] )
				{
					case 'f':	// ׯ ؏ƍ
						verifyFlash = true;
						break;

					case 'e':	// EEPROMƍ
						verifyEEPROM = true;
						break;

					case 'b':	// ƍ
						verifyFlash = true;
						verifyEEPROM = true;
						break;

					default:
						throw new ErrorMsg( "Unknown choice for -v, use -vf, -ve or -vb!" );
				}

				break;

			case 'x':	// w؂𖞂
				if( strlen( param ) != 4 )
					throw new ErrorMsg( "Use two hex digits for the -x parameter!" );

				try
				{
					memoryFillPattern = convertHex( param + 2 );
				}
				catch( ErrorMsg * e )
				{
					delete e;
					throw new ErrorMsg( "Hex number format error for -x parameter!" );
				}

				break;

			case 'y':	// {ޯēǂݍ
				if( strlen( param ) != 2 )
					throw new ErrorMsg( "Parameter -y needs no extra arguments!" );

				readLockBits = true;
				break;

			case 'z':	// i\Ȃ?
				if( strlen( param ) != 2 )
					throw new ErrorMsg( "Parameter -z needs no extra arguments!" );

				noProgressIndicator = true;
				break;

			default:
				throw new ErrorMsg( "Unknow parameter!" );
		}
	}
}

void JobInfo::help()
{
	cout
		<< "Command Line Switches:" << endl
		<< "        [-d device name] [-if infile] [-ie infile] [-of outfile] [-oe outfile]" << endl
		<< "        [-s] [-O index] [-O#value] [-Sf addr] [-Se addr] [-e] [-p f|e|b]" << endl
		<< "        [-r f|e|b] [-v f|e|b] [-l value] [-L value] [-y] [-f value] [-E value]" << endl
		<< "        [-F value] [-G value] [-q] [-x value] [-af start,stop] [-ae start,stop]" << endl
		<< "        [-c port] [-b h|s] [-g] [-z] [-h|?]" << endl
		<< endl
		<< "Parameters:" << endl
		<< "d       Device name. Must be applied when programming the device." << endl
		<< "if      Name of FLASH input file. Required for programming or verification" << endl
		<< "        of the FLASH memory. The file format is Intel Extended HEX." << endl
		<< "ie      Name of EEPROM input file. Required for programming or verification" << endl
		<< "        of the EEPROM memory. The file format is Intel Extended HEX." << endl
		<< "of      Name of FLASH output file. Required for readout of the FLASH memory." << endl
		<< "        The file format is Intel Extended HEX." << endl
		<< "oe      Name of EEPROM output file. Required for readout of the EEPROM" << endl
		<< "        memory. The file format is Intel Extended HEX." << endl
		<< "s       Read signature bytes." << endl;
	getch();
	cout
		<< "O       Read oscillator calibration byte. 'index' is optional." << endl
		<< "O#      User-defined oscillator calibration value." << endl
		<< "Sf      Write oscillator cal. byte to FLASH memory. 'addr' is byte address." << endl
		<< "Se      Write oscillator cal. byte to EEPROM memory. 'addr' is byte address." << endl
		<< "e       Erase device. If applied with another programming parameter, the" << endl
		<< "        device will be erased before any other programming takes place." << endl
		<< "p       Program device; FLASH (f), EEPROM (e) or both (b). Corresponding" << endl
		<< "        input files are required." << endl
		<< "r       Read out device; FLASH (f), EEPROM (e) or both (b). Corresponding" << endl
		<< "        output files are required" << endl
		<< "v       Verify device; FLASH (f), EEPROM (e) or both (b). Can be used with" << endl
		<< "        -p or alone. Corresponding input files are required." << endl
		<< "l       Set lock byte. 'value' is an 8-bit hex. value." << endl
		<< "L       Verify lock byte. 'value' is an 8-bit hex. value to verify against." << endl
		<< "y       Read back lock byte." << endl
		<< "f       Set fuse bytes. 'value' is a 16-bit hex. value describing the" << endl
		<< "        settings for the upper and lower fuse bytes." << endl
		<< "E       Set extended fuse byte. 'value' is an 8-bit hex. value describing the" << endl
		<< "        extend fuse settings." << endl
		<< "F       Verify fuse bytes. 'value' is a 16-bit hex. value to verify against." << endl;
	getch();
	cout
		<< "G       Verify extended fuse byte. 'value' is an 8-bit hex. value to" << endl
		<< "        verify against." << endl
		<< "q       Read back fuse bytes." << endl
		<< "x       Fill unspecified locations with a value (00-ff). The default is" << endl
		<< "        to not program locations not specified in the input files." << endl
		<< "af      FLASH address range. Specifies the address range of operations. The" << endl
		<< "        default is the entire FLASH. Byte addresses in hex." << endl
		<< "ae      EEPROM address range. Specifies the address range of operations." << endl
		<< "        The default is the entire EEPROM. Byte addresses in hex." << endl
		<< "c       Select communication port; 'COM1' to 'COM8'. If this parameter is" << endl
		<< "        omitted the program will scan the COM ports for a programmer." << endl
		<< "b       Get revisions; hardware revision (h) and software revision (s)." << endl
		<< "g       Silent operation." << endl
		<< "z       No progress indicator. E.g. if piping to a file for log purposes, use" << endl
		<< "        this option to avoid the characters used for the indicator." << endl
		<< "h|?     Help information (overrides all other settings)." << endl
		<< endl
		<< "Example:" << endl
		<< "        AVROSP -dATmega128 -ifmyapp.hex -pf" << endl;
}

long JobInfo::convertHex( char * txt )
{
	string t( txt );
	return Util.convertHex( t );
}

void JobInfo::doJob()
{
	long scanCOM;
	SerialPort * com;
	AVRProgrammer * prog;
	AVRDevice * avr;
	string programmerID;
	long sig0, sig1, sig2;					// [޲

	/* ÎƐi\̏Ԃݒ */
	if( silentMode )
	{
		Util.muteLog();
		Util.muteProgress();				// Î͐i\܂
	}

	if( noProgressIndicator )
		Util.muteProgress();

	if( showHelp )
	{
		help();
		return;
	}

	/* COM߰đKv? */
	if( comPort == -1 )
	{
		Util.log( "Scanning COM ports for supported programmer...\n\r" );

		for( scanCOM = 1; scanCOM <= 8; scanCOM++ )
		{
			Util.progress( "COM" + Util.convertLong( scanCOM ) + "...\r\n" );

			try
			{
				/* ʐMs */
				com = NULL;
				com = new SerialPort( scanCOM, TIMEOUT );
				com->openChannel();
				programmerID = AVRProgrammer::readProgrammerID( com );

				/* ڐG! IDAƎͯގ[ɒǉ */
				if( programmerID == "AVRBOOT" || programmerID == "AVR ISP" )
				{
					break;
				}

				delete com;
				Util.progress( programmerID + " found - not supported!\r\n" );
			}
			catch( ErrorMsg * e )
			{
				/* COM߰ĂŐڐGȂA֔ */
				if( com != NULL ) delete com;
				delete e;
			}
		}

		/* x鏑݊킪SȂꍇɔo */
		if( scanCOM > 8 )
		{
			Util.log( "No supported programmers found!\r\n" );
			return;
		}

		comPort = scanCOM;

	} else									// COM߰ĎwL
	{
		/* ʐMsAُ͌Ăяoɓ`B܂B */
		com = new SerialPort( comPort, TIMEOUT );
		com->openChannel();
//		programmerID = AVRProgrammer::readProgrammerID( com );

		/* ڐG! ID */
//		if( programmerID != "AVRBOOT" && programmerID != "AVR ISP" )
//			throw new ErrorMsg( "Programmer not supported!" );
	}

//	Util.log( "Found " + programmerID + " on COM" + Util.convertLong( comPort ) + "!\r\n" );

	/* ̪݊ ޼ުč쐬AƎɒǉ */
//	if( programmerID == "AVRBOOT" )
//	{
	prog = new AVRBootloader( com );
//	}

//	Util.log( "Entering programming mode...\r\n" );
//	prog->enterProgrammingMode(); // Ignore return code.

	/* uƖ֌Wȑs */
	doDeviceIndependent( prog );

	/* uw肳ȂꍇɏI */
//	if( deviceName.size() == 0 )
//	{
//		Util.log( "Device name not specified!\r\n" );
//		return;
//	}

	/* XML޲Lq̧ق */
	avr = new AVRDevice( deviceName );
//	Util.log( "Parsing XML file for device parameters...\r\n" );
//	Util.parsePath( searchpath );
//	avr->readParametersFromAVRStudio( searchpath );

	/* ޲[XMĻق̎[Əƍ */
//	avr->getSignature( &sig0, &sig1, &sig2 );
//	if( prog->checkSignature( sig0, sig1, sig2 ) )
//		Util.log( "Signature matches device!\r\n" );

	/* uƖ֌Wȑs */
	doDeviceDependent( prog, avr );

	/* | */
//	Util.log( "Leaving programming mode...\r\n" );
//	prog->leaveProgrammingMode();			// Ԃ蕄𖳎

	delete avr;
	delete prog;
	delete com;
}

void JobInfo::doDeviceIndependent( AVRProgrammer * prog )
{
	long sig0, sig1, sig2;					// [޲
	long minor, major;						// ƕ̏݊ԍ

	/* [ǂݍ? */
	if( readSignature )
	{
		Util.log( "Reading signature bytes: " );
		if( !prog->readSignature( &sig0, &sig1, &sig2 ) )
			throw new ErrorMsg( "Signature readout is not supported by this programmer!" );

		/* gp҂]ނ߁AUtilʂēnȂ */
		cout.fill( '0' );
		cout << hex
			<< "0x" << setw(2) << sig0 << " "
			<< "0x" << setw(2) << sig1 << " "
			<< "0x" << setw(2) << sig2 << endl;
	}

	/* ĳŔԍ擾? */
	if( getSWrevision )
	{
		Util.log( "Reading programmer software revision: " );
		if( !prog->programmerSoftwareVersion( &major, &minor ) )
			throw new ErrorMsg( "Software revision readout is not supported by this programmer!" );

		/* gp҂]ނ߁AUtilʂēnȂ */
		cout << (char) (major & 0xff) << "." << (char) (minor & 0xff) << endl;
	}

	/* ĳŔԍ擾? */
	if( getHWrevision )
	{
		Util.log( "Reading programmer hardware revision: " );
		if( !prog->programmerHardwareVersion( &major, &minor ) )
			throw new ErrorMsg( "Hardware revision readout is not supported by this programmer!" );

		/* gp҂]ނ߁AUtilʂēnȂ */
		cout << (char) (major & 0xff) << "." << (char) (minor & 0xff) << endl;
	}
}

void JobInfo::doDeviceDependent( AVRProgrammer * prog, AVRDevice * avr )
{
	HEXFile * hex;
	HEXFile * hex_v;						// ؓeƍɎgp
	long pos;								// ްrɎgp
	long bits;								// {ޯĂ˭ ޯĂɎgp

	/* ݊߰ޗeʐݒ */
	prog->setPagesize( avr->getPageSize() );

	/* w肳ꂽڽx޲͈͓ */
	if( flashEndAddress != -1 )
	{
		if( flashEndAddress >= avr->getFlashSize() )
			throw new ErrorMsg( "Specified Flash address range is outside device address space!" );
	} else
	{
		flashStartAddress = 0;
		flashEndAddress = avr->getFlashSize() - 1;
	}

	if( eepromEndAddress != -1 )
	{
		if( eepromEndAddress >= avr->getEEPROMSize() )
			throw new ErrorMsg( "Specified EEPROM address range is outside device address space!" );
	} else
	{
		eepromStartAddress = 0;
		eepromEndAddress = avr->getEEPROMSize() - 1;
	}

	/* ׯeǂݏo? */
	if( readFlash )
	{
		/* ̧ٖw肳ꂽ */
		if( outputFileFlash.size() == 0 )
			throw new ErrorMsg( "Cannot read Flash without output file specified!" );

		/* ُ̧ */
		hex = new HEXFile( avr->getFlashSize() );
		hex->setUsedRange( flashStartAddress, flashEndAddress );

		/* ްǂݍ̧݂ٕۑ */
		Util.log( "Reading Flash contents...\r\n" );
		if( !prog->readFlash( hex ) )
			throw new ErrorMsg( "Flash readout is not supported by this programmer!" );
		Util.log( "Writing HEX output file...\r\n" );
		hex->writeFile( outputFileFlash );

		delete hex;
	}

	/* EEPROMeǂݏo? */
	if( readEEPROM )
	{
		/* ̧ٖw肳ꂽ */
		if( outputFileEEPROM.size() == 0 )
			throw new ErrorMsg( "Cannot read EEPROM without output file specified!" );

		/* ُ̧ */
		hex = new HEXFile( avr->getEEPROMSize() );
		hex->setUsedRange( eepromStartAddress, eepromEndAddress );

		/* ްǂݍ̧݂ٕۑ */
		Util.log( "Reading EEPROM contents...\r\n" );
		if( !prog->readEEPROM( hex ) )
			throw new ErrorMsg( "EEPROM readout is not supported by this programmer!" );
		Util.log( "Writing HEX output file...\r\n" );
		hex->writeFile( outputFileEEPROM );

		delete hex;
	}

	/* {ޯēǂݍ? */
	if( readLockBits )
	{
//		Util.log( "Reading lock bits...\r\n" );
		if( !prog->readLockBits( &bits ) )
			throw new ErrorMsg( "Lock bit readout is not supported by this programmer!" );
		cout << "0x" << std::hex << setw(2) << bits << endl;
	}

	/* ˭ ޯēǂݍ(ʏƊg̗)? */
	if( readFuseBits )
	{
		if( !avr->getFuseStatus() )
			throw new ErrorMsg( "Selected device has no fuse bits!" );

		Util.log( "Reading fuse bits...\r\n" );
		if( !prog->readFuseBits( &bits ) )
			throw new ErrorMsg( "Fuse bit readout is not supported by this programmer!" );
		cout << "0x" << std::hex << setw(4) << bits << endl;

		if( avr->getXFuseStatus() )
		{
			if( !prog->readExtendedFuseBits( &bits ) )
				throw new ErrorMsg( "Extended fuse bit readout is not supported by this programmer!" );
			cout << "0x" << std::hex << setw(2) << bits << endl;
		}
	}

	/* ޑO߂? */
	if( chipErase )
	{
		Util.log( "Erasing chip contents...\r\n" );
		if( !prog->chipErase() )
			throw new ErrorMsg( "Chip erase is not supported by this programmer!" );
	}

	/* ׯpHEX̧ق */
	if( programFlash || verifyFlash )
	{
		/* ̧ٖw肳ꂽ */
		if( inputFileFlash.size() == 0 )
			throw new ErrorMsg( "Cannot program or verify Flash without input file specified!" );

		/* ُ̧ */
		hex = new HEXFile( avr->getFlashSize() );

		/* ]܂ꂽȂΖ */
		if( memoryFillPattern != -1 )
			hex->clearAll( memoryFillPattern );

		/* ̧ٓǂݍ */
		Util.log( "Reading HEX input file for flash operations...\r\n" );
		hex->readFile( inputFileFlash );

		/* x */
		if( hex->getRangeStart() > flashEndAddress ||
				hex->getRangeEnd() < flashStartAddress )
			throw new ErrorMsg( "HEX file defines data outside specified range!" );

		if( memoryFillPattern == -1 )
		{
			if( hex->getRangeStart() > flashStartAddress )
				flashStartAddress = hex->getRangeStart();

			if( hex->getRangeEnd() < flashEndAddress )
				flashEndAddress = hex->getRangeEnd();
		}

		hex->setUsedRange( flashStartAddress, flashEndAddress );
	}

	/* Vׯe? */
	if( programFlash )
	{
		/* ް */
		Util.log( "Programming Flash contents...\r\n" );
		if( !prog->writeFlash( hex ) )
			throw new ErrorMsg( "Flash programming is not supported by this programmer!" );
	}

	/* ׯeƍ? */
	if( verifyFlash )
	{
		/* rpHEX̧ق */
		hex_v = new HEXFile( avr->getFlashSize() );

		/* ׯƔr */
		Util.log( "Reading Flash contents...\r\n" );
		hex_v->setUsedRange( hex->getRangeStart(), hex->getRangeEnd() );
		if( !prog->readFlash( hex_v ) )
			throw new ErrorMsg( "Flash readout is not supported by this programmer!" );

		/* ްr */
		Util.log( "Comparing Flash data...\r\n" );

		for( pos = hex->getRangeStart(); pos <= hex->getRangeEnd(); pos++ )
		{
			if( hex->getData( pos ) != hex_v->getData( pos ) )
			{
				cout << "Unequal at address 0x" << std::hex << pos << "!" << endl;
				break;
			}
		}

		if( pos > hex->getRangeEnd() )		// Sē?
		{
			cout << "Equal!" << endl;
		}

		delete hex_v;
	}

	if( programFlash || verifyFlash )
        delete hex;

	/* EEPROMpHEX̧ق */
	if( programEEPROM || verifyEEPROM )
	{
		/* ̧ٖw肳ꂽ */
		if( inputFileEEPROM.size() == 0 )
			throw new ErrorMsg( "Cannot program or verify EEPROM without input file specified!" );

		/* ُ̧ */
		hex = new HEXFile( avr->getEEPROMSize() );

		/* ]܂ꂽȂΖ */
//		if( memoryFillPattern != -1 )
		// EEPROMɉ$FF̑ɑS0ɐݒ
		hex->clearAll( 0 );

		/* ̧ٓǂݍ݂Ɠe */
		Util.log( "Reading HEX input file for EEPROM operations...\r\n" );
		hex->readFile( inputFileEEPROM );

		/* x */
		if( hex->getRangeStart() > eepromEndAddress ||
				hex->getRangeEnd() < eepromStartAddress )
			throw new ErrorMsg( "HEX file defines data outside specified range!" );

		if( memoryFillPattern == -1 )
		{
			if( hex->getRangeStart() > eepromStartAddress )
				eepromStartAddress = hex->getRangeStart();

			if( hex->getRangeEnd() < eepromEndAddress )
				eepromEndAddress = hex->getRangeEnd();
		}

		hex->setUsedRange( eepromStartAddress, eepromEndAddress );
	}

	/* VEEPROMe? */
	if( programEEPROM )
	{
		/* ް */
		Util.log( "Programming EEPROM contents...\r\n" );
		if( !prog->writeEEPROM( hex ) )
			throw new ErrorMsg( "EEPROM programming is not supported by this programmer!" );
	}

	/* EEPROMeƍ? */
	if( verifyEEPROM )
	{
		/* rpHEX̧ق */
		hex_v = new HEXFile( avr->getEEPROMSize() );

		/* EEPROMƔr */
		Util.log( "Reading EEPROM contents...\r\n" );
		hex_v->setUsedRange( hex->getRangeStart(), hex->getRangeEnd() );
		if( !prog->readEEPROM( hex_v ) )
			throw new ErrorMsg( "EEPROM readout is not supported by this programmer!" );

		/* ްr */
		Util.log( "Comparing EEPROM data...\r\n" );
		for( pos = hex->getRangeStart(); pos <= hex->getRangeEnd(); pos++ )
		{
			if( hex->getData( pos ) != hex_v->getData( pos ) )
			{
				cout << "Unequal at address 0x" << std::hex << pos << "!" << endl;
				break;
			}
		}

		if( pos > hex->getRangeEnd() )		// Sē?
		{
			cout << "Equal!" << endl;
		}

		delete hex_v;
	}

	if( programEEPROM || verifyEEPROM )
		delete hex;

	/* {ޯď */
	if( programLockBits != -1 )
	{
//		Util.log( "Programming lock bits...\r\n" );
		if( !prog->writeLockBits( programLockBits ) )
			throw new ErrorMsg( "Lock bit programming is not supported by this programmer!" );
	}

	/* ˭ ޯď */
	if( programFuseBits != -1 )
	{
		if( !avr->getFuseStatus() )
			throw new ErrorMsg( "Selected device has no fuse bits!" );

		Util.log( "Programming fuse bits...\r\n" );
		if( !prog->writeFuseBits( programFuseBits ) )
			throw new ErrorMsg( "Fuse bit programming is not supported by this programmer!" );
	}

	/* g˭ ޯď */
	if( programExtendedFuseBits != -1 )
	{
		if( !avr->getXFuseStatus() )
			throw new ErrorMsg( "Selected device has no extended fuse bits!" );

		Util.log( "Programming extended fuse bits...\r\n" );
		if( !prog->writeExtendedFuseBits( programExtendedFuseBits ) )
			throw new ErrorMsg( "Extended fuse bit programming is not supported by this programmer!" );
	}

	/* {ޯďƍ */
	if( verifyLockBits != -1 )
	{
		Util.log( "Verifying lock bits...\r\n" );
		if( !prog->readLockBits( &bits ) )
			throw new ErrorMsg( "Lock bit readout is not supported by this programmer!" );
		if( bits == verifyLockBits )
			cout << "Equal!" << endl;
		else
			cout << "Unequal!" << endl;
	}

	/* ˭ ޯďƍ */
	if( verifyFuseBits != -1 )
	{
		if( !avr->getFuseStatus() )
			throw new ErrorMsg( "Selected device has no fuse bits!" );

		Util.log( "Verifying fuse bits...\r\n" );
		if( !prog->readFuseBits( &bits ) )
			throw new ErrorMsg( "Fuse bit readout is not supported by this programmer!" );
		if( bits == verifyFuseBits )
			cout << "Equal!" << endl;
		else
			cout << "Unequal!" << endl;
	}

	/* g˭ ޯďƍ */
	if( verifyExtendedFuseBits != -1 )
	{
		if( !avr->getXFuseStatus() )
			throw new ErrorMsg( "Selected device has no extended fuse bits!" );

		Util.log( "Verifying extended fuse bits...\r\n" );
		if( !prog->readExtendedFuseBits( &bits ) )
			throw new ErrorMsg( "Extended fuse bit readout is not supported by this programmer!" );
		if( bits == verifyExtendedFuseBits )
			cout << "Equal!" << endl;
		else
			cout << "Unequal!" << endl;
	}

	/* OSCCALlǂݍ? */
	if( OSCCAL_Parameter != -1 )
	{
		/* ޲ǂݍ݂Ȃ΋L^ɏo */
		if( readOSCCAL )
		{
			Util.log( "Reading OSCCAL from device...\r\n" );
			pos = OSCCAL_Parameter;
			if( !prog->readOSCCAL( pos, &OSCCAL_Parameter ) )
				throw new ErrorMsg( "OSCCAL parameter readout is not supported by this programmer!" );
			cout << "0x" << std::hex << setw(2) << OSCCAL_Parameter << endl;
		}
	}

	/* ׯOSCCAL? */
	if( OSCCAL_FlashAddress != -1 )
	{
		if( OSCCAL_Parameter == -1 )
			throw new ErrorMsg( "OSCCAL value not specified!" );

		Util.log( "Programming OSCCAL value to Flash...\r\n" );
		if( !prog->writeFlashByte( OSCCAL_FlashAddress, OSCCAL_Parameter ) )
			throw new ErrorMsg( "Flash programming is not supported by this programmer!" );
	}

	/* EEPROMOSCCAL? */
	if( OSCCAL_EEPROMAddress != -1 )
	{
		if( OSCCAL_Parameter == -1 )
			throw new ErrorMsg( "OSCCAL value not specified!" );

		Util.log( "Programming OSCCAL value to EEPROM...\r\n" );
		if( !prog->writeEEPROMByte( OSCCAL_EEPROMAddress, OSCCAL_Parameter ) )
			throw new ErrorMsg( "EEPROM programming is not supported by this programmer!" );
	}

}

/* ̧ق̍Ō */
